Index: tools/rosunit/src/rosunit/core.py
===================================================================
--- tools/rosunit/src/rosunit/core.py	(revision 12349)
+++ tools/rosunit/src/rosunit/core.py	(working copy)
@@ -32,7 +32,7 @@
 #
 # Revision $Id$
 
-import os
+import os, sys
 import logging
 import roslib.rosenv
 
@@ -45,19 +45,21 @@
     if args:
         msg = msg%args
     _logger.info(msg)
-    print "[ROSUNIT]"+msg
+    print("[ROSUNIT]"+msg)
     
 def printlog_bold(msg, *args):
     if args:
         msg = msg%args
     _logger.info(msg)
-    print '\033[1m[ROSUNIT]%s\033[0m'%msg
+    #print('\033[1m[ROSUNIT]%s\033[0m'%msg)
+    # For now, removing the ANSI sequence that corrupt the XML result files when running tests
+    print('[ROSUNIT]%s'%msg)
     
 def printerrlog(msg, *args):
     if args:
         msg = msg%args
     _logger.error(msg)
-    print >> sys.stderr, "[ROSUNIT]"+msg
+    sys.stderr.write("[ROSUNIT] " + msg + "\n")
 
 def xml_results_file(test_pkg, test_name, is_rostest=False):
     """
@@ -130,7 +132,7 @@
     elif os.path.isfile(test_dir):
         raise Exception("ERROR: cannot run test suite, file is preventing creation of test dir: %s"%test_dir)
     
-    print "[ROSUNIT] Outputting test results to %s"%results_file
+    print("[ROSUNIT] Outputting test results to %s"%results_file)
     outstream = open(results_file, 'w')
     return XMLTestRunner(stream=outstream)
     
Index: tools/rosunit/src/rosunit/pyunit.py
===================================================================
--- tools/rosunit/src/rosunit/pyunit.py	(revision 12349)
+++ tools/rosunit/src/rosunit/pyunit.py	(working copy)
@@ -109,10 +109,10 @@
             _cov.load()
             _cov.start()
         except coverage.CoverageException:
-            print >> sys.stderr, "WARNING: you have an older version of python-coverage that is not support. Please update to the version provided by 'easy_install coverage'"
-    except ImportError, e:
-        print >> sys.stderr, """WARNING: cannot import python-coverage, coverage tests will not run.
-To install coverage, run 'easy_install coverage'"""
+            sys.stderr.write("WARNING: you have an older version of python-coverage that is not support. Please update to the version provided by 'easy_install coverage'\n")
+    except ImportError as e:
+        sys.stderr.write("""WARNING: cannot import python-coverage, coverage tests will not run.
+To install coverage, run 'easy_install coverage'\n""")
 
 def stop_coverage(packages, html=None):
     """
@@ -148,23 +148,23 @@
             # iterate over packages to generate per-package console reports
             for package in packages:
                 pkg = __import__(package)
-                m = [v for v in sys.modules.values() if v and v.__name__.startswith(package)]
+                m = [v for v in list(sys.modules.values()) if v and v.__name__.startswith(package)]
                 all_mods.extend(m)
 
                 # generate overall report and per module analysis
                 _cov.report(m, show_missing=0)
                 for mod in m:
                     res = _cov.analysis(mod)
-                    print "\n%s:\nMissing lines: %s"%(res[0], res[3])
+                    print("\n%s:\nMissing lines: %s"%(res[0], res[3]))
                     
             if html:
                 
-                print "="*80+"\ngenerating html coverage report to %s\n"%html+"="*80
+                print("="*80+"\ngenerating html coverage report to %s\n"%html+"="*80)
                 _cov.html_report(all_mods, directory=html)
-        except ImportError, e:
-            print >> sys.stderr, "WARNING: cannot import '%s', will not generate coverage report"%package
-    except ImportError, e:
-        print >> sys.stderr, """WARNING: cannot import python-coverage, coverage tests will not run.
-To install coverage, run 'easy_install coverage'"""
+        except ImportError as e:
+            sys.stderr.write("WARNING: cannot import '%s', will not generate coverage report\n"%package)
+    except ImportError as e:
+        sys.stderr.write("""WARNING: cannot import python-coverage, coverage tests will not run.
+To install coverage, run 'easy_install coverage'\n""")
     
     
Index: tools/rosunit/src/rosunit/baretest.py
===================================================================
--- tools/rosunit/src/rosunit/baretest.py	(revision 12349)
+++ tools/rosunit/src/rosunit/baretest.py	(working copy)
@@ -38,7 +38,12 @@
 """
 
 import os
-import cStringIO
+
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+
 import unittest
 import logging
 import time
@@ -142,7 +147,7 @@
                         raise TestTimeoutException("test max time allotted")
                     time.sleep(0.1)
                 
-            except TestTimeoutException, e:
+            except TestTimeoutException as e:
                 if self.retry:
                     timeout_failure = True
                 else:
@@ -241,7 +246,8 @@
         if not os.path.exists(log_dir):
             try:
                 os.makedirs(log_dir)
-            except OSError, (errno, msg):
+            except OSError as err:
+                (errno, msg) = err.args
                 if errno == 13:
                     raise RLException("unable to create directory for log file [%s].\nPlease check permissions."%log_dir)
                 else:
@@ -295,7 +301,7 @@
             # _configure_logging() can mutate self.args
             try:
                 logfileout, logfileerr = self._configure_logging()
-            except Exception, e:
+            except Exception as e:
                 _logger.error(traceback.format_exc())
                 printerrlog("[%s] ERROR: unable to configure logging [%s]"%(self.name, str(e)))
                 # it's not safe to inherit from this process as
@@ -317,7 +323,8 @@
 
             try:
                 self.popen = subprocess.Popen(self.args, cwd=cwd, stdout=logfileout, stderr=logfileerr, env=full_env, close_fds=True, preexec_fn=os.setsid)
-            except OSError, (errno, msg):
+            except OSError as err:
+                (errno, msg) = err.args
                 self.started = True # must set so is_alive state is correct
                 _logger.error("OSError(%d, %s)", errno, msg)
                 if errno == 8: #Exec format error
@@ -431,7 +438,7 @@
                         #self.popen.wait()
                         #os.wait()
                         _logger.info("process[%s]: sent SIGKILL", self.name)
-                    except OSError, e:
+                    except OSError as e:
                         if e.args[0] == 3:
                             printerrlog("no [%s] process with pid [%s]"%(self.name, pid))
                         else:
@@ -486,7 +493,7 @@
     # (i.e. doesn't check for actual test success). The 'r' result
     # object contains results of the actual tests.
     
-    buff = cStringIO.StringIO()
+    buff = StringIO()
     buff.write("[%s]"%(runner_name)+'-'*71+'\n\n')
     for tc_result in junit_results.test_case_results:
         buff.write(tc_result.description)
@@ -520,14 +527,14 @@
         for tc_result in runner_results.failures:
             buff.write(" * " +tc_result[0]._testMethodName + "\n")
 
-    print buff.getvalue()
+    print(buff.getvalue())
 
 def print_unittest_summary(result):
     """
     Print summary of python unittest result to stdout
     @param result: test results
     """
-    buff = cStringIO.StringIO()
+    buff = StringIO()
     buff.write("-------------------------------------------------------------\nSUMMARY:\n")
     if result.wasSuccessful():
         buff.write("\033[32m * RESULT: SUCCESS\033[0m\n")
@@ -536,5 +543,5 @@
     buff.write(" * TESTS: %s\n"%result.testsRun)
     buff.write(" * ERRORS: %s [%s]\n"%(len(result.errors), ', '.join([e[0]._testMethodName for e in result.errors])))
     buff.write(" * FAILURES: %s [%s]\n"%(len(result.failures), ','.join([e[0]._testMethodName for e in result.failures])))
-    print buff.getvalue()
+    print(buff.getvalue())
 
Index: tools/rosunit/src/rosunit/pmon.py
===================================================================
--- tools/rosunit/src/rosunit/pmon.py	(revision 12349)
+++ tools/rosunit/src/rosunit/pmon.py	(working copy)
@@ -36,14 +36,19 @@
 Process monitor
 """
 
-from __future__ import with_statement
 
+
 import os
 import sys
 import time
 import traceback
 import logging
-import Queue
+
+try:
+    import queue
+except ImportError:
+    import Queue as queue
+
 import atexit
 from threading import Thread, RLock, Lock
 
@@ -51,6 +56,15 @@
 
 _logger = logging.getLogger("rosunit")          
 
+def isstring(s):
+    """Small helper version to check an object is a string in a way that works
+    for both Python 2 and 3
+    """
+    try:
+        return isinstance(s, basestring)
+    except NameError:
+        return isinstance(s, str)
+
 class PmonException(Exception): pass
 
 class FatalProcessLaunch(PmonException):
@@ -112,7 +126,7 @@
         else:
             _logger.debug("shutdown_process_monitor: ProcessMonitor shutdown succeeded")
             return True
-    except Exception, e:
+    except Exception as e:
         return False
 
 _shutdown_lock = Lock()
@@ -341,7 +355,7 @@
         method was called.
         @rtype: bool
         """
-        if not isinstance(name, basestring):
+        if not isstring(name):
             raise PmonException("kill_process takes in a process name but was given: %s"%name)
         _logger.debug("ProcessMonitor.kill_process[%s]"%name)
         printlog("[%s] kill requested"%name)
@@ -436,7 +450,7 @@
                         for l in self.listeners:
                             l.process_died(p.name, p.exit_code)
 
-                except Exception, e:
+                except Exception as e:
                     traceback.print_exc()
                     #don't respawn as this is an internal error
                     dead.append(p)
@@ -482,7 +496,7 @@
         self.is_shutdown = True
         # killall processes on run exit
 
-        q = Queue.Queue()
+        q = queue.Queue()
         q.join()
         
         with self.plock:
@@ -559,7 +573,7 @@
                 p = q.get(False)
                 _kill_process(p, self.errors)
                 q.task_done()
-            except Queue.Empty:
+            except queue.Empty:
                 pass
 
         
Index: tools/rosunit/src/rosunit/junitxml.py
===================================================================
--- tools/rosunit/src/rosunit/junitxml.py	(revision 12349)
+++ tools/rosunit/src/rosunit/junitxml.py	(working copy)
@@ -39,7 +39,12 @@
 
 import os
 import sys
-import cStringIO
+
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+
 import string
 import codecs
 import re
@@ -69,14 +74,14 @@
     'error' result container        
     """
     def xml(self):
-        return u'<error type="%s"><![CDATA[%s]]></error>'%(self.type, self.text)            
+        return '<error type="%s"><![CDATA[%s]]></error>'%(self.type, self.text)            
 
 class TestFailure(TestInfo):
     """
     'failure' result container        
     """
     def xml(self):
-        return u'<failure type="%s"><![CDATA[%s]]></failure>'%(self.type, self.text)            
+        return '<failure type="%s"><![CDATA[%s]]></failure>'%(self.type, self.text)            
 
 
 class TestCaseResult(object):
@@ -153,7 +158,7 @@
         self.errors.append(error)
 
     def xml(self):
-        return u'  <testcase classname="%s" name="%s" time="%s">\n'%(self.classname, self.name, self.time)+\
+        return '  <testcase classname="%s" name="%s" time="%s">\n'%(self.classname, self.name, self.time)+\
                '\n    '.join([f.xml() for f in self.failures])+\
                '\n    '.join([e.xml() for e in self.errors])+\
                '  </testcase>'
@@ -198,7 +203,7 @@
         """
         @return: document as unicode (UTF-8 declared) XML according to Ant JUnit spec
         """
-        return u'<?xml version="1.0" encoding="utf-8"?>'+\
+        return '<?xml version="1.0" encoding="utf-8"?>'+\
                '<testsuite name="%s" tests="%s" errors="%s" failures="%s" time="%s">'%\
                (self.name, self.num_tests, self.num_errors, self.num_failures, self.time)+\
                '\n'.join([tc.xml() for tc in self.test_case_results])+\
@@ -207,7 +212,10 @@
                '</testsuite>'
 
 def _text(tag):
-    return reduce(lambda x, y: x + y, [c.data for c in tag.childNodes if c.nodeType in [DomNode.TEXT_NODE, DomNode.CDATA_SECTION_NODE]], "").strip()
+    res = ""
+    for n in [c.data for c in tag.childNodes if c.nodeType in [DomNode.TEXT_NODE, DomNode.CDATA_SECTION_NODE]]:
+        res += n.strip()
+    return res
 
 def _load_suite_results(test_suite_name, test_suite, result):
     nodes = [n for n in test_suite.childNodes \
@@ -260,17 +268,6 @@
                     x = TestError(d.getAttribute('type') or '', text)
                     tc_result.add_error(x)
 
-## #603: unit test suites are not good about screening out illegal
-## unicode characters. This little recipe I from http://boodebr.org/main/python/all-about-python-and-unicode#UNI_XML
-## screens these out
-RE_XML_ILLEGAL = u'([\u0000-\u0008\u000b-\u000c\u000e-\u001f\ufffe-\uffff])' + \
-                 u'|' + \
-                 u'([%s-%s][^%s-%s])|([^%s-%s][%s-%s])|([%s-%s]$)|(^[%s-%s])' % \
-                 (unichr(0xd800),unichr(0xdbff),unichr(0xdc00),unichr(0xdfff),
-                  unichr(0xd800),unichr(0xdbff),unichr(0xdc00),unichr(0xdfff),
-                  unichr(0xd800),unichr(0xdbff),unichr(0xdc00),unichr(0xdfff))
-_safe_xml_regex = re.compile(RE_XML_ILLEGAL)
-
 def _read_file_safe_xml(test_file):
     """
     read in file, screen out unsafe unicode characters
@@ -286,9 +283,24 @@
             f = codecs.open(test_file, "r", "iso8859-1" )
             x = f.read()        
 
-        for match in _safe_xml_regex.finditer(x):
-            x = x[:match.start()] + "?" + x[match.end():]
-        return x.encode("utf-8")
+        ## #603: unit test suites are not good about screening out illegal
+        ## unicode characters. This little recipe I from http://boodebr.org/main/python/all-about-python-and-unicode#UNI_XML
+        ## screens these out
+
+        if sys.version_info[0] < 3:
+            #~ RE_XML_ILLEGAL = '([\u0000-\u0008\u000b-\u000c\u000e-\u001f\ufffe-\uffff])' + \
+                             #~ '|' + \
+                             #~ '([%s-%s][^%s-%s])|([^%s-%s][%s-%s])|([%s-%s]$)|(^[%s-%s])' % \
+                             #~ (chr(0xd800),chr(0xdbff),chr(0xdc00),chr(0xdfff),
+                              #~ chr(0xd800),chr(0xdbff),chr(0xdc00),chr(0xdfff),
+                              #~ chr(0xd800),chr(0xdbff),chr(0xdc00),chr(0xdfff))
+            #~ _safe_xml_regex = re.compile(RE_XML_ILLEGAL)
+            #~ 
+            #~ for match in _safe_xml_regex.finditer(x):
+                #~ x = x[:match.start()] + "?" + x[match.end():]
+            return x.encode("utf-8")
+        else: #Python 3 unicode support *should* handle everything. Not throughfully tested however :-)
+            return x
     finally:
         f.close()
 
@@ -305,18 +317,18 @@
     try:
         xml_str = _read_file_safe_xml(test_file)
         test_suite = parseString(xml_str).getElementsByTagName('testsuite')
-    except Exception, e:
+    except Exception as e:
         import traceback
         traceback.print_exc()
-        print "WARN: cannot read test result file [%s]: %s"%(test_file, str(e))
+        print("WARN: cannot read test result file [%s]: %s"%(test_file, str(e)))
         return Result(test_name, 0, 0, 0)
     if not test_suite:
-        print "WARN: test result file [%s] contains no results"%test_file
+        print("WARN: test result file [%s] contains no results"%test_file)
         return Result(test_name, 0, 0, 0)
     test_suite = test_suite[0]
     vals = [test_suite.getAttribute(attr) for attr in ['errors', 'failures', 'tests']]
     vals = [v or 0 for v in vals]
-    err, fail, tests = [string.atoi(val) for val in vals]
+    err, fail, tests = [int(val) for val in vals]
 
     result = Result(test_name, err, fail, tests)
     result.time = test_suite.getAttribute('time') or 0.0    
@@ -410,32 +422,31 @@
     # (i.e. doesn't check for actual test success). The 'r' result
     # object contains results of the actual tests.
     
-    buff = cStringIO.StringIO()
-    buff.write("[%s]"%runner_name+'-'*71+'\n\n')
+    buff = "[%s]"%runner_name+'-'*71+'\n\n'
     for tc_result in junit_results.test_case_results:
-        buff.write(tc_result.description)
+        buff += tc_result.description
 
-    buff.write('\nSUMMARY\n')
+    buff += '\nSUMMARY\n'
     if (junit_results.num_errors + junit_results.num_failures) == 0:
-        buff.write("\033[32m * RESULT: SUCCESS\033[0m\n")
+        buff += "\033[32m * RESULT: SUCCESS\033[0m\n"
     else:
-        buff.write("\033[1;31m * RESULT: FAIL\033[0m\n")
+        buff += "\033[1;31m * RESULT: FAIL\033[0m\n"
 
     # TODO: still some issues with the numbers adding up if tests fail to launch
 
     # number of errors from the inner tests, plus add in count for tests
     # that didn't run properly ('result' object).
-    buff.write(" * TESTS: %s\n"%junit_results.num_tests)
+    buff += " * TESTS: %s\n"%junit_results.num_tests
     num_errors = junit_results.num_errors
     if num_errors:
-        buff.write("\033[1;31m * ERRORS: %s\033[0m\n"%num_errors)
+        buff += "\033[1;31m * ERRORS: %s\033[0m\n"%num_errors
     else:
-        buff.write(" * ERRORS: 0\n")
+        buff += " * ERRORS: 0\n"
     num_failures = junit_results.num_failures
     if num_failures:
-        buff.write("\033[1;31m * FAILURES: %s\033[0m\n"%num_failures)
+        buff += "\033[1;31m * FAILURES: %s\033[0m\n"%num_failures
     else:
-        buff.write(" * FAILURES: 0\n")
+        buff += " * FAILURES: 0\n"
 
-    print buff.getvalue()
+    print(buff)
 
Index: tools/rosunit/src/rosunit/xmlrunner.py
===================================================================
--- tools/rosunit/src/rosunit/xmlrunner.py	(revision 12349)
+++ tools/rosunit/src/rosunit/xmlrunner.py	(working copy)
@@ -13,12 +13,15 @@
 import time
 import traceback
 import unittest
-from StringIO import StringIO
+
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+    
 from xml.sax.saxutils import escape
 
-from StringIO import StringIO
 
-
 class _TestInfo(object):
 
     """Information about a particular test.
@@ -357,7 +360,7 @@
         """
         class TestTest(unittest.TestCase):
             def test_foo(self):
-                print "Test"
+                print("Test")
         self._try_test_run(TestTest, """<testsuite errors="0" failures="0" name="unittest.TestSuite" tests="1" time="0.000">
   <testcase classname="__main__.TestTest" name="test_foo" time="0.000"></testcase>
   <system-out><![CDATA[Test
@@ -373,7 +376,7 @@
         """
         class TestTest(unittest.TestCase):
             def test_foo(self):
-                print >>sys.stderr, "Test"
+                sys.stderr.write("Test\n")
         self._try_test_run(TestTest, """<testsuite errors="0" failures="0" name="unittest.TestSuite" tests="1" time="0.000">
   <testcase classname="__main__.TestTest" name="test_foo" time="0.000"></testcase>
   <system-out><![CDATA[]]></system-out>
Index: tools/rosunit/src/rosunit/rosunit_main.py
===================================================================
--- tools/rosunit/src/rosunit/rosunit_main.py	(revision 12349)
+++ tools/rosunit/src/rosunit/rosunit_main.py	(working copy)
@@ -32,8 +32,8 @@
 #
 # Revision $Id$
 
-from __future__ import with_statement
 
+
 import os
 import sys
 import time
@@ -56,7 +56,7 @@
     logfile_basename = 'rosunit-%s.log'%(test_name)
     logfile_name = roslib.roslogging.configure_logging('rosunit-%s'%(test_name), filename=logfile_basename)
     if logfile_name:
-        print "... logging to %s"%logfile_name
+        print("... logging to %s"%logfile_name)
     return logfile_name
 
 def rosunitmain():
@@ -122,10 +122,10 @@
     if not options.text_mode:
         print_runner_summary(runner_result, results)
     else:
-        print "WARNING: overall test result is not accurate when --text is enabled"
+        print("WARNING: overall test result is not accurate when --text is enabled")
 
     if logfile_name:
-        print "rosunit log file is in %s"%logfile_name
+        print("rosunit log file is in %s"%logfile_name)
         
     if not runner_result.wasSuccessful():
         sys.exit(1)
Index: tools/rosboost_cfg/src/rosboost_cfg/rosboost_cfg.py
===================================================================
--- tools/rosboost_cfg/src/rosboost_cfg/rosboost_cfg.py	(revision 12349)
+++ tools/rosboost_cfg/src/rosboost_cfg/rosboost_cfg.py	(working copy)
@@ -38,8 +38,12 @@
 import subprocess
 import platform
 from optparse import OptionParser
-from cStringIO import StringIO
 
+try:
+    from cStringIO import StringIO # Python 2.x
+except ImportError:
+    from io import StringIO # Python 3.x
+
 lib_suffix = "so"
 if (sys.platform == "darwin"):
   lib_suffix = "dylib"
@@ -60,12 +64,12 @@
         boost_version.append(0)
 
 def print_usage_and_exit():
-  print >> sys.stderr, "Usage: rosboost-cfg --lflags [thread,regex,graph,...]"
-  print >> sys.stderr, "       rosboost-cfg --cflags"
-  print >> sys.stderr, "       rosboost-cfg --libs [thread,regex,graph,...]"
-  print >> sys.stderr, "       rosboost-cfg --include_dirs"
-  print >> sys.stderr, "       rosboost-cfg --lib_dirs"
-  print >> sys.stderr, "       rosboost-cfg --root"
+  print("Usage: rosboost-cfg --lflags [thread,regex,graph,...]")
+  print("       rosboost-cfg --cflags")
+  print("       rosboost-cfg --libs [thread,regex,graph,...]")
+  print("       rosboost-cfg --include_dirs")
+  print("       rosboost-cfg --lib_dirs")
+  print("       rosboost-cfg --root")
   sys.exit(1)
 
 class BoostError(Exception):
@@ -270,19 +274,18 @@
         return ' -l%s'%(os.path.splitext(lib)[0][len('lib'):])
 
 def lflags(ver, libs):
-    s = StringIO()
-    print >> s, lib_dir_flags(ver),
+    s= lib_dir_flags(ver) + " "
     for lib in libs:
-        print >> s, lib_flags(ver, lib),
+        s += lib_flags(ver, lib) + " "
     
-    return s.getvalue()
+    return s
 
 def libs(ver, libs):
-    s = StringIO()
+    s = ""
     for lib in libs:
-        print >> s, find_lib(ver, lib, True),
+        s += find_lib(ver, lib, True) + " "
     
-    return s.getvalue()
+    return s
 
 def lib_dirs(ver):
     if (ver.is_default_search_location or no_L_or_I):
@@ -319,7 +322,7 @@
     if (options.print_versions):
         check_one_option(options, 'print_versions')
         for ver in find_versions(search_paths(options.sysroot)):
-            print '%s.%s.%s root=%s include_dir=%s'%(ver.major, ver.minor, ver.patch, ver.root, ver.include_dir)
+            print('%s.%s.%s root=%s include_dir=%s'%(ver.major, ver.minor, ver.patch, ver.root, ver.include_dir))
         return
        
     ver = find_boost(search_paths(options.sysroot))
@@ -330,7 +333,7 @@
     
     if (options.version):
         check_one_option(options, 'version')
-        print '%s.%s.%s root=%s include_dir=%s'%(ver.major, ver.minor, ver.patch, ver.root, ver.include_dir)
+        print('%s.%s.%s root=%s include_dir=%s'%(ver.major, ver.minor, ver.patch, ver.root, ver.include_dir))
         return
     
     if (ver.major < 1 or (ver.major == 1 and ver.minor < 37)):
@@ -360,7 +363,7 @@
     else:
         print_usage_and_exit()
     
-    print output.strip()
+    print(output.strip())
 
 if __name__ == "__main__":
     main()
Index: tools/rosboost_cfg/src/rosboost_cfg/__init__.py
===================================================================
--- tools/rosboost_cfg/src/rosboost_cfg/__init__.py	(revision 12349)
+++ tools/rosboost_cfg/src/rosboost_cfg/__init__.py	(working copy)
@@ -30,4 +30,4 @@
 # ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 
-from rosboost_cfg import *
+from .rosboost_cfg import *
Index: tools/rosdep/src/rosdep/core.py
===================================================================
--- tools/rosdep/src/rosdep/core.py	(revision 12349)
+++ tools/rosdep/src/rosdep/core.py	(working copy)
@@ -32,8 +32,8 @@
 #Library and command-line tool for calculating rosdeps.
 #"""
 
-from __future__ import with_statement
 
+
 import roslib.rospack
 import roslib.stacks
 import roslib.manifest
@@ -58,7 +58,7 @@
 
 
 yaml.add_constructor(
-    u'tag:yaml.org,2002:float',
+    'tag:yaml.org,2002:float',
     yaml.constructor.Constructor.construct_yaml_str)
 
 class YamlCache:
@@ -83,8 +83,8 @@
                 self._yaml_cache[path] = yaml.load(yaml_text)
                 return self._yaml_cache[path]
 
-            except yaml.YAMLError, exc:
-                print >> sys.stderr, "Failed parsing yaml while processing %s\n"%path, exc
+            except yaml.YAMLError as exc:
+                sys.stderr.write("Failed parsing yaml while processing %s: %s\n"%(path, exc))
                 #sys.exit(1)        # not a breaking error
         self._yaml_cache[path] = {}
         return {}
@@ -128,7 +128,7 @@
         if type(os_specific) == type("String"):
             return os_specific
         else:# it must be a map of versions
-            if self.os_version in os_specific.keys():
+            if self.os_version in list(os_specific.keys()):
                 return os_specific[self.os_version]
             #print >> sys.stderr, "failed to find definition of %s for OS(%s) Version(%s) within '''%s'''. Defined in file %s"%(rosdep_name, self.os_name, self.os_version, os_specific, source_path)
             return False                    
@@ -173,9 +173,9 @@
         try:
             rosdep_dependent_packages = ros_package_proxy.depends([package])[package]
             #print "package", package, "needs", rosdep_dependent_packages
-        except KeyError, ex:
-            print "Depends Failed on package", ex
-            print " The errors was in ",  ros_package_proxy.depends([package])
+        except KeyError as ex:
+            print("Depends Failed on package", ex)
+            print(" The errors was in ",  ros_package_proxy.depends([package]))
             rosdep_dependent_packages = []
         #print "Dependents of", package, rosdep_dependent_packages
         rosdep_dependent_packages.append(package)
@@ -186,25 +186,25 @@
             stack = None
             try:
                 stack = roslib.stacks.stack_of(p)
-            except roslib.packages.InvalidROSPkgException, ex:
-                print >> sys.stderr, "Failed to find stack for package [%s]"%p
+            except roslib.packages.InvalidROSPkgException as ex:
+                sys.stderr.write("Failed to find stack for package [%s]\n"%p)
                 pass
             if stack:
                 try:
                     paths.add( os.path.join(roslib.stacks.get_stack_dir(stack), "rosdep.yaml"))
-                except AttributeError, ex:
-                    print "Stack [%s] could not be found"%(stack)
+                except AttributeError as ex:
+                    print("Stack [%s] could not be found"%(stack))
                 for s in self.yaml_cache.get_rosstack_depends(stack):
                     try:
                         paths.add( os.path.join(roslib.stacks.get_stack_dir(s), "rosdep.yaml"))
-                    except AttributeError, ex:
-                        print "Stack [%s] dependency of [%s] could not be found"%(s, stack)
+                    except AttributeError as ex:
+                        print("Stack [%s] dependency of [%s] could not be found"%(s, stack))
                         
             else:
                 try:
                     paths.add( os.path.join(roslib.packages.get_pkg_dir(p), "rosdep.yaml"))
-                except roslib.packages.InvalidROSPkgException, ex:
-                    print >> sys.stderr, "Failed to load rosdep.yaml for package [%s]:%s"%(p, ex)
+                except roslib.packages.InvalidROSPkgException as ex:
+                    sys.stderr.write("Failed to load rosdep.yaml for package [%s]:%s"%(p, ex))
                     pass
         for path in paths:
             self.insert_map(self.parse_yaml(path), path)
@@ -225,7 +225,7 @@
 
 
                 if override:
-                    print >>sys.stderr, "ROSDEP_OVERRIDE: %s being overridden with %s from %s"%(key, yaml_dict[key], source_path)
+                    sys.stderr.write("ROSDEP_OVERRIDE: %s being overridden with %s from %s"%(key, yaml_dict[key], source_path))
                     self.rosdep_source[key].append("Overriding with "+source_path)
                     self.rosdep_map[key] = rosdep_entry
                 else:
@@ -258,7 +258,7 @@
         if rosdep in self.rosdep_map:
             return self.rosdep_map[rosdep]
         else:
-            print >> sys.stderr, "Failed to find rosdep %s for package %s on OS:%s version:%s"%(rosdep, self.package, self.os_name, self.os_version)
+            sys.stderr.write("Failed to find rosdep %s for package %s on OS:%s version:%s"%(rosdep, self.package, self.os_name, self.os_version))
             return False
         
     def get_map(self):
@@ -307,7 +307,7 @@
         yc = YamlCache(self.osi.get_name(), self.osi.get_version())
         start_time = time.time()
         if "ROSDEP_DEBUG" in os.environ:
-            print "Generating package list and scripts for %d rosdeps.  This may take a few seconds..."%len(self.packages)
+            print("Generating package list and scripts for %d rosdeps.  This may take a few seconds..."%len(self.packages))
         for p in self.packages:
             rdlp = RosdepLookupPackage(self.osi.get_name(), self.osi.get_version(), p, yc)
             for r in self.rosdeps[p]:
@@ -325,11 +325,11 @@
             if not self.robust:
                 raise RosdepException("ABORTING: Rosdeps %s could not be resolved"%failed_rosdeps)
             else:
-                print >> sys.stderr, "WARNING: Rosdeps %s could not be resolved"%failed_rosdeps
+                sys.stderr.write("WARNING: Rosdeps %s could not be resolved"%failed_rosdeps)
 
         time_delta = (time.time() - start_time)
         if "ROSDEP_DEBUG" in os.environ:
-            print "Done loading rosdeps in %f seconds, averaging %f per rosdep."%(time_delta, time_delta/len(self.packages))
+            print("Done loading rosdeps in %f seconds, averaging %f per rosdep."%(time_delta, time_delta/len(self.packages)))
 
         return (list(set(native_packages)), list(set(scripts)))
 
@@ -348,8 +348,8 @@
         scripts = []
         try:
             native_packages, scripts = self.get_packages_and_scripts()
-        except RosdepException, e:
-            print >> sys.stderr, e
+        except RosdepException as e:
+            sys.stderr.write(str(e) + "\n")
             pass
         undetected = self.osi.get_os().strip_detected_packages(native_packages)
         return_str = ""
@@ -378,7 +378,7 @@
             fh.write(script)
             fh.flush()
             
-            print "rosdep executing this script:\n{{{\n%s\n}}}"%script
+            print("rosdep executing this script:\n{{{\n%s\n}}}"%script)
             p= subprocess.Popen(['bash', fh.name], stderr=subprocess.PIPE )
             (out, err) = p.communicate()
             if p.returncode != 0:
